Index: XIOS/trunk/src/client_client_dht_decl.cpp
===================================================================
--- XIOS/trunk/src/client_client_dht_decl.cpp	(revision 828)
+++ XIOS/trunk/src/client_client_dht_decl.cpp	(revision 829)
@@ -13,4 +13,5 @@
 
 template class CClientClientDHTTemplate<int>;
+template class CClientClientDHTTemplate<PairIntInt>;
 
 }
Index: XIOS/trunk/src/client_client_dht_template.hpp
===================================================================
--- XIOS/trunk/src/client_client_dht_template.hpp	(revision 828)
+++ XIOS/trunk/src/client_client_dht_template.hpp	(revision 829)
@@ -16,4 +16,6 @@
 #include "policy.hpp"
 #include <boost/unordered_map.hpp>
+//#include "utils.hpp"
+#include "dht_data_types.hpp"
 
 namespace xios
@@ -33,8 +35,10 @@
     typedef T InfoType;
     static const int infoTypeSize = sizeof(InfoType);
+    typedef typename boost::unordered_map<InfoType, std::vector<size_t> > InfoType2IndexMap;
+    typedef typename boost::unordered_map<size_t,InfoType> Index2InfoTypeMap;
 
   public:
     /** Default constructor */
-    CClientClientDHTTemplate(const boost::unordered_map<size_t,T>& indexInfoInitMap,
+    CClientClientDHTTemplate(const Index2InfoTypeMap& indexInfoInitMap,
                              const MPI_Comm& clientIntraComm,
                              int hierarLvl = 2);
@@ -42,5 +46,5 @@
     void computeIndexInfoMapping(const CArray<size_t,1>& indices);
 
-    const std::map<T, std::vector<size_t> >& getInfoIndexMap() const {return indexGlobalOnServer_; }
+    const Index2InfoTypeMap& getInfoIndexMap() const {return infoIndexMapping_; }
 
     /** Default destructor */
@@ -49,5 +53,5 @@
   protected:
     // Redistribute index and info among clients
-    void computeDistributedIndex(const boost::unordered_map<size_t,T>& indexInfoInitMap,
+    void computeDistributedIndex(const Index2InfoTypeMap& indexInfoInitMap,
                                  const MPI_Comm& intraCommLevel,
                                  int level);
@@ -67,8 +71,8 @@
                                       const MPI_Comm& intraComm);
 
-    void probeInfoMessageFromClients(InfoType* recvIndexServerBuff,
+    void probeInfoMessageFromClients(unsigned char* recvIndexServerBuff,
                                      const int recvNbIndexCount,
                                      int& countIndexServer,
-                                     std::map<int, InfoType*>& indexServerBuffBegin,
+                                     std::map<int, unsigned char*>& indexServerBuffBegin,
                                      std::map<int, MPI_Request>& requestRecvIndexServer,
                                      const MPI_Comm& intraComm);
@@ -93,11 +97,11 @@
   protected:
     //! Mapping of global index to the corresponding client
-    boost::unordered_map<size_t,InfoType> index2InfoMapping_;
+    Index2InfoTypeMap index2InfoMapping_;
 
     //! A temporary mapping of index to the corresponding information in each level of hierarchy
-    boost::unordered_map<size_t,InfoType> indexToInfoMappingLevel_;
+    Index2InfoTypeMap indexToInfoMappingLevel_;
 
-    //! Global index of data on SERVER, which are calculated by client(s)
-    std::map<int, std::vector<size_t> > indexGlobalOnServer_;
+    //! Data (information) corresponding to global index
+    Index2InfoTypeMap infoIndexMapping_;
 
     //! intracommuntion of clients
@@ -109,4 +113,5 @@
 
 typedef CClientClientDHTTemplate<int> CClientClientDHTInt;
+typedef CClientClientDHTTemplate<PairIntInt> CClientClientDHTPairIntInt;
 
 } // namespace xios
Index: XIOS/trunk/src/client_client_dht_template_impl.hpp
===================================================================
--- XIOS/trunk/src/client_client_dht_template_impl.hpp	(revision 828)
+++ XIOS/trunk/src/client_client_dht_template_impl.hpp	(revision 829)
@@ -49,6 +49,7 @@
   for (size_t idx = 0; idx < size; ++idx)
   {
-    int serverIdx = indexToInfoMappingLevel_[indices(idx)];
-    indexGlobalOnServer_[serverIdx].push_back(indices(idx));
+    T& info = indexToInfoMappingLevel_[indices(idx)];
+//    infoIndexMapping_[info].push_back(indices(idx));
+    infoIndexMapping_[indices(idx)] = info;
   }
 }
@@ -125,8 +126,9 @@
 
   // Buffer to receive respond from other clients, it can be allocated or not depending whether it demands other clients
-  InfoType* recvBuffInfo = 0;
+//  InfoType* recvBuffInfo = 0;
+  unsigned char* recvBuffInfo = 0;
   int nbIndexReceivedFromOthers = nbIndexToSend;
   if (0 != nbIndexReceivedFromOthers)
-    recvBuffInfo = new InfoType[nbIndexReceivedFromOthers];
+    recvBuffInfo = new unsigned char[nbIndexReceivedFromOthers*infoTypeSize];
 
   std::map<int, MPI_Request>::iterator itRequest;
@@ -212,5 +214,5 @@
 
   // Mapping client rank and the begining position of receiving buffer for message of server index from this client
-  std::map<int, InfoType*> infoBuffBegin;
+  std::map<int, unsigned char*> infoBuffBegin;
 
   while ((!sendInfoRequest.empty()) || (nbSendBuffInfoReceived < nbIndexReceivedFromOthers))
@@ -233,13 +235,17 @@
       if (true == flagInfo)
       {
-        MPI_Get_count(&statusInfo, MPI_INT, &count);
+        MPI_Get_count(&statusInfo, MPI_CHAR, &count);
+        int actualCountInfo = count/infoTypeSize;
         int clientSourceRank = statusInfo.MPI_SOURCE;
-        InfoType* beginBuff = infoBuffBegin[clientSourceRank];
+        unsigned char* beginBuff = infoBuffBegin[clientSourceRank];
         std::vector<size_t>& indexTmp = client2ClientIndex[clientSourceRank];
-        for (int i = 0; i < count; ++i)
+        TypeToBytes<InfoType> u;
+        for (int i = 0; i < actualCountInfo; ++i)
         {
-          indexToInfoMapping[indexTmp[i]] = *(beginBuff+i);
+          unsigned char* tmpBeginBuff = beginBuff+i*infoTypeSize;
+          for (size_t idx = 0; idx < infoTypeSize; ++idx) u.bytes[idx] = *(tmpBeginBuff+idx);
+          indexToInfoMapping[indexTmp[i]] = u.value;
         }
-        nbSendBuffInfoReceived += count;
+        nbSendBuffInfoReceived += actualCountInfo;
         repondAlreadyReceived.push_back(clientSourceRank);
       }
@@ -251,5 +257,5 @@
   }
 
-  indexToInfoMappingLevel_ = indexToInfoMapping;
+  indexToInfoMappingLevel_.swap(indexToInfoMapping);
   if (0 != maxNbIndexDemandedFromOthers) delete [] recvBuffIndex;
   if (0 != nbIndexReceivedFromOthers) delete [] recvBuffInfo;
@@ -289,6 +295,6 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::computeDistributedIndex(const boost::unordered_map<size_t,T>& indexInfoMap,
-                                                          const MPI_Comm& commLevel,
-                                                          int level)
+                                                            const MPI_Comm& commLevel,
+                                                            int level)
 {
   int nbClient, clientRank;
@@ -340,5 +346,5 @@
   int recvNbIndexCount = recvNbIndexBuff[clientRank];
   unsigned long* recvIndexBuff = new unsigned long[recvNbIndexCount];
-  InfoType* recvInfoBuff = new InfoType[recvNbIndexCount];
+  unsigned char* recvInfoBuff = new unsigned char[recvNbIndexCount*infoTypeSize];
 
   // If a client holds information about index and the corresponding which don't belong to it,
@@ -374,5 +380,5 @@
 
   // Mapping client rank and the begining position of receiving buffer for message of server index from this client
-  std::map<int, int*> infoBuffBegin;
+  std::map<int, unsigned char*> infoBuffBegin;
 
   boost::unordered_map<size_t,InfoType> indexToInfoMapping;
@@ -418,6 +424,12 @@
       {
         int count = it->second;
+        TypeToBytes<InfoType> u;
         for (int i = 0; i < count; ++i)
-           indexToInfoMapping.insert(std::make_pair<size_t,InfoType>(*(indexBuffBegin[rank]+i),*(infoBuffBegin[rank]+i)));
+        {
+          unsigned char* tmpBeginBuff = infoBuffBegin[rank]+i*infoTypeSize;
+          for (size_t idx = 0; idx < infoTypeSize; ++idx) u.bytes[idx] = *(tmpBeginBuff+idx);
+          indexToInfoMapping.insert(std::make_pair<size_t,InfoType>(*(indexBuffBegin[rank]+i),u.value));
+        }
+
         processedList.push_back(rank);
         --recvNbClient;
@@ -466,9 +478,9 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::probeIndexMessageFromClients(unsigned long* recvIndexBuff,
-                                                    const int recvNbIndexCount,
-                                                    int& countIndex,
-                                                    std::map<int, unsigned long*>& indexBuffBegin,
-                                                    std::map<int, MPI_Request>& requestRecvIndex,
-                                                    const MPI_Comm& intraComm)
+                                                                 const int recvNbIndexCount,
+                                                                 int& countIndex,
+                                                                 std::map<int, unsigned long*>& indexBuffBegin,
+                                                                 std::map<int, MPI_Request>& requestRecvIndex,
+                                                                 const MPI_Comm& intraComm)
 {
   MPI_Status statusIndexGlobal;
@@ -500,10 +512,10 @@
 */
 template<typename T, typename H>
-void CClientClientDHTTemplate<T,H>::probeInfoMessageFromClients(T* recvInfoBuff,
-                                                   const int recvNbIndexCount,
-                                                   int& countInfo,
-                                                   std::map<int, T*>& infoBuffBegin,
-                                                   std::map<int, MPI_Request>& requestRecvInfo,
-                                                   const MPI_Comm& intraComm)
+void CClientClientDHTTemplate<T,H>::probeInfoMessageFromClients(unsigned char* recvInfoBuff,
+                                                                const int recvNbIndexCount,
+                                                                int& countInfo,
+                                                                std::map<int, unsigned char*>& infoBuffBegin,
+                                                                std::map<int, MPI_Request>& requestRecvInfo,
+                                                                const MPI_Comm& intraComm)
 {
   MPI_Status statusInfo;
@@ -515,6 +527,7 @@
   {
     MPI_Get_count(&statusInfo, MPI_CHAR, &count);
-    infoBuffBegin.insert(std::make_pair<int, T*>(statusInfo.MPI_SOURCE, recvInfoBuff+countInfo));
-    MPI_Irecv(recvInfoBuff+countInfo, count, MPI_CHAR,
+    unsigned char* beginInfoBuff = recvInfoBuff+countInfo*infoTypeSize;
+    infoBuffBegin.insert(std::make_pair<int, unsigned char*>(statusInfo.MPI_SOURCE, beginInfoBuff));
+    MPI_Irecv(beginInfoBuff, count, MPI_CHAR,
               statusInfo.MPI_SOURCE, MPI_DHT_INFO, intraComm,
               &requestRecvInfo[statusInfo.MPI_SOURCE]);
@@ -533,6 +546,6 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::sendIndexToClients(int clientDestRank, std::vector<size_t>& indices,
-                                          const MPI_Comm& clientIntraComm,
-                                          std::list<MPI_Request>& requestSendIndex)
+                                                       const MPI_Comm& clientIntraComm,
+                                                       std::list<MPI_Request>& requestSendIndex)
 {
   MPI_Request request;
@@ -551,6 +564,6 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::sendInfoToClients(int clientDestRank, std::vector<T>& info,
-                                         const MPI_Comm& clientIntraComm,
-                                         std::list<MPI_Request>& requestSendInfo)
+                                                      const MPI_Comm& clientIntraComm,
+                                                      std::list<MPI_Request>& requestSendInfo)
 {
   MPI_Request request;
Index: XIOS/trunk/src/client_server_mapping.cpp
===================================================================
--- XIOS/trunk/src/client_server_mapping.cpp	(revision 828)
+++ XIOS/trunk/src/client_server_mapping.cpp	(revision 829)
@@ -12,5 +12,5 @@
 
 CClientServerMapping::CClientServerMapping()
-  : indexGlobalOnServer_(), localIndexSend2Server_(), connectedClients_()
+  : indexGlobalOnServer_(), connectedClients_() //, localIndexSend2Server_()
 {
 }
@@ -20,51 +20,51 @@
 }
 
-/*!
-  Compute mapping global index of server which client sends to.
-  \param [in] globalIndexOnClient global index on client
-  \param [in] globalIndexServer global index of servers
-*/
-void CClientServerMapping::computeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient,
-                                                     const std::vector<CArray<size_t,1>* >& globalIndexServer)
-{
-  defaultComputeServerIndexMapping(globalIndexOnClient, globalIndexServer);
-}
+///*!
+//  Compute mapping global index of server which client sends to.
+//  \param [in] globalIndexOnClient global index on client
+//  \param [in] globalIndexServer global index of servers
+//*/
+//void CClientServerMapping::computeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient,
+//                                                     const std::vector<CArray<size_t,1>* >& globalIndexServer)
+//{
+//  defaultComputeServerIndexMapping(globalIndexOnClient, globalIndexServer);
+//}
 
-/*!
-   Compute index of data which are sent to server and index global on server side
-   \param [in] globalIndexOnClient global index of data on client
-   \param [in] globalIndexServer global index of server(s)
-   \param [in] localIndexOnClient local index of data on client which are sent to server
-*/
-void CClientServerMapping::defaultComputeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient,
-                                                            const std::vector<CArray<size_t,1>* >& globalIndexServer,
-                                                            const CArray<int,1>* localIndexOnClient)
-{
-  int nServer = globalIndexServer.size();
-  std::vector<CArray<size_t,1>::const_iterator> itBegin(nServer), itEnd(nServer), it(nServer);
-  for (int i = 0; i < nServer; ++i)
-  {
-    itBegin[i] = it[i] = globalIndexServer[i]->begin();
-    itEnd[i]   = globalIndexServer[i]->end();
-  }
-
-  size_t ssize = globalIndexOnClient.numElements();
-  for (int i = 0; i < ssize; ++i)
-  {
-    for (int j = 0; j < nServer; ++j)
-    {
-      // Just temporarily, it's bad.
-      if (std::binary_search(itBegin[j], itEnd[j], globalIndexOnClient(i)))
-      {
-        // Just try to calculate local index server on client side
-        (indexGlobalOnServer_[j]).push_back((globalIndexOnClient)(i));
-        if (0 != localIndexOnClient) (localIndexSend2Server_[j]).push_back((*localIndexOnClient)(i));
-        else
-          (localIndexSend2Server_[j]).push_back(i);
-        continue;
-      }
-    }
-  }
-}
+///*!
+//   Compute index of data which are sent to server and index global on server side
+//   \param [in] globalIndexOnClient global index of data on client
+//   \param [in] globalIndexServer global index of server(s)
+//   \param [in] localIndexOnClient local index of data on client which are sent to server
+//*/
+//void CClientServerMapping::defaultComputeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient,
+//                                                            const std::vector<CArray<size_t,1>* >& globalIndexServer,
+//                                                            const CArray<int,1>* localIndexOnClient)
+//{
+//  int nServer = globalIndexServer.size();
+//  std::vector<CArray<size_t,1>::const_iterator> itBegin(nServer), itEnd(nServer), it(nServer);
+//  for (int i = 0; i < nServer; ++i)
+//  {
+//    itBegin[i] = it[i] = globalIndexServer[i]->begin();
+//    itEnd[i]   = globalIndexServer[i]->end();
+//  }
+//
+//  size_t ssize = globalIndexOnClient.numElements();
+//  for (int i = 0; i < ssize; ++i)
+//  {
+//    for (int j = 0; j < nServer; ++j)
+//    {
+//      // Just temporarily, it's bad.
+//      if (std::binary_search(itBegin[j], itEnd[j], globalIndexOnClient(i)))
+//      {
+//        // Just try to calculate local index server on client side
+//        (indexGlobalOnServer_[j]).push_back((globalIndexOnClient)(i));
+//        if (0 != localIndexOnClient) (localIndexSend2Server_[j]).push_back((*localIndexOnClient)(i));
+//        else
+//          (localIndexSend2Server_[j]).push_back(i);
+//        continue;
+//      }
+//    }
+//  }
+//}
 
 /*!
@@ -134,12 +134,12 @@
 }
 
-/*!
-  Return local index of data that is send to server
-  \return mapping of server rank and local index of sending data on the client
-*/
-const std::map<int, std::vector<int> >& CClientServerMapping::getLocalIndexSendToServer() const
-{
-  return localIndexSend2Server_;
-}
+///*!
+//  Return local index of data that is send to server
+//  \return mapping of server rank and local index of sending data on the client
+//*/
+//const CClientServerMapping::LocalIndexMap& CClientServerMapping::getLocalIndexSendToServer() const
+//{
+//  return localIndexSend2Server_;
+//}
 
 /*!
@@ -149,5 +149,5 @@
   \return mapping of server rank and its global index.
 */
-const std::map<int, std::vector<size_t> >& CClientServerMapping::getGlobalIndexOnServer() const
+const CClientServerMapping::GlobalIndexMap& CClientServerMapping::getGlobalIndexOnServer() const
 {
   return indexGlobalOnServer_;
Index: XIOS/trunk/src/client_server_mapping.hpp
===================================================================
--- XIOS/trunk/src/client_server_mapping.hpp	(revision 828)
+++ XIOS/trunk/src/client_server_mapping.hpp	(revision 829)
@@ -13,4 +13,5 @@
 #include "array_new.hpp"
 #include "mpi.hpp"
+#include <boost/unordered_map.hpp>
 
 namespace xios {
@@ -23,4 +24,7 @@
 class CClientServerMapping
 {
+public:
+  typedef boost::unordered_map<int, std::vector<size_t> > GlobalIndexMap;
+  typedef std::map<int, std::vector<int> > LocalIndexMap;
   public:
     /** Default constructor */
@@ -33,11 +37,7 @@
     virtual void computeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient) = 0;
 
-//    // In case of computing local index on client sent to server
+//    // Simple case, global index on client and index on servers
 //    virtual void computeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient,
-//                                           const CArray<int,1>& localIndexOnClient) = 0;
-
-    // Simple case, global index on client and index on servers
-    virtual void computeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient,
-                                           const std::vector<CArray<size_t,1>* >& globalIndexOnServer);
+//                                           const std::vector<CArray<size_t,1>* >& globalIndexOnServer);
 
     static std::map<int,int> computeConnectedClients(int nbServer, int nbClient,
@@ -45,18 +45,18 @@
                                                      const std::vector<int>& connectedServerRank);
 
-    const std::map<int, std::vector<size_t> >& getGlobalIndexOnServer() const;
-    const std::map<int, std::vector<int> >& getLocalIndexSendToServer() const;
+    const GlobalIndexMap& getGlobalIndexOnServer() const;
+//    const LocalIndexMap& getLocalIndexSendToServer() const;
 
   protected:
-    void defaultComputeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient,
-                                          const std::vector<CArray<size_t,1>* >& globalIndexOnServer,
-                                          const CArray<int,1>* localIndexOnClient = 0);
+//    void defaultComputeServerIndexMapping(const CArray<size_t,1>& globalIndexOnClient,
+//                                          const std::vector<CArray<size_t,1>* >& globalIndexOnServer,
+//                                          const CArray<int,1>* localIndexOnClient = 0);
 
   protected:
     //! Global index of data on SERVER, which are calculated by client(s)
-    std::map<int, std::vector<size_t> > indexGlobalOnServer_;
+    GlobalIndexMap indexGlobalOnServer_;
 
     //! Index of the local data which will be sent to the corresponding server(s)
-    std::map<int, std::vector<int> >  localIndexSend2Server_;
+//    LocalIndexMap  localIndexSend2Server_;
 
     //!< Number of clients connected to a server
